=== debian/changelog ===
pocl (1.4-6) unstable; urgency=medium

  * Update symbols files.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 05 Feb 2020 20:55:06 +0100

pocl (1.4-5) experimental; urgency=medium

  * Update symbols files.
  * Switch to llvm 9.
  * Bump Standards-Version to 4.5.0, no changes needed.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 31 Jan 2020 17:11:45 +0100

pocl (1.4-4) unstable; urgency=medium

  * Postpone clinfo failures after dh_makeshlibs, too.
  * Work around add_test_pocl() ignoring SKIP_RETURN_CODE.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 28 Jan 2020 12:02:47 +0100

pocl (1.4-3) unstable; urgency=medium

  * Update symbols files.
  * Fix clash with altivec macros on ppc64el.
  * Skip subdevice tests on (virtual) single core CPUs.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 19 Jan 2020 15:58:32 +0100

pocl (1.4-2) experimental; urgency=medium

  * Update symbols files.
  * Switch to llvm 8.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 16 Jan 2020 03:03:18 +0100

pocl (1.4-1) experimental; urgency=medium

  * New upstream release.
  * Refresh/remove patches.
  * Link kernels with libm to avoid missing fma/fmaf/... symbols.
  * Ignore regression/struct_kernel_arguments failure on i686.
  * Switch back to llvm 7 for now.
  * Update symbols files for amd64 and i386.
  * Fix build on GNU/hurd, thanks to Samuel Thibault.  (Closes: #947881)
  * Update copyright holders and years.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 04 Jan 2020 11:08:11 +0100

pocl (1.3-10) unstable; urgency=medium

  * Use upstream version of upstreamed patches.
  * Backport "Use libdl directly" and related fixes from 1.4.
    (Closes: #946582, #946422)
  * Drop B-D on libltdl-dev.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 26 Dec 2019 23:19:15 +0100

pocl (1.3-9) unstable; urgency=medium

  * Bump Standards-Version to 4.4.1, no changes needed.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 09 Oct 2019 23:15:27 +0200

pocl (1.3-8) experimental; urgency=medium

  * Switch to llvm 8.
  * Update symbols files for amd64 and i386.
  * Backport "Fixes to global memory size detection" from 1.4.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 25 Sep 2019 00:48:51 +0200

pocl (1.3-7) unstable; urgency=medium

  * Try a fix for allocation limit computation on kfreebsd-i386.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 24 Sep 2019 00:55:41 +0200

pocl (1.3-6) experimental; urgency=medium

  * Update symbols files.
  * Ignore workgroup/loop_with_two_paths_to_the_latch_LOOPS failures.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 14 Sep 2019 19:49:14 +0200

pocl (1.3-5) experimental; urgency=medium

  * Switch to llvm 7, again.  (Closes: #912793, #932707)
  * Update symbols files for amd64 and i386.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 27 Aug 2019 18:35:12 +0200

pocl (1.3-4) unstable; urgency=medium

  * Enable --exclude-libs on kFreeBSD.
  * Tune symbols files.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 06 Sep 2019 23:13:34 +0200

pocl (1.2-10) experimental; urgency=medium

  * Switch to llvm 7.  (Closes: #912793)
  * Update symbols files.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 11 Feb 2019 16:56:57 +0100
